datablock ParticleData(SeawolfSiloExhaustParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -3;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/cloud";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (154/255) SPC (73/255) SPC (10/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (100/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (1/255);

	sizes[0]      = 4;
	sizes[1]      = 5;
	sizes[2]      = 6;
	sizes[3]      = 8;

	times[0] = 0;
	times[1] = 0.3;
	times[2] = 0.5;
	times[3] = 1.0;
	useInvAlpha = true;
};

datablock ParticleEmitterData(SeawolfSiloExhaustEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 30.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 15;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfSiloExhaustParticle";
};
datablock ParticleData(SeawolfSiloRingParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/cloud";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (154/255) SPC (73/255) SPC (10/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (100/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (1/255);

	sizes[0]      = 4;
	sizes[1]      = 4;
	sizes[2]      = 4;
	sizes[3]      = 8;

	times[0] = 0;
	times[1] = 0.005;
	times[2] = 0.0055;
	times[3] = 1.0;
	useInvAlpha = true;
};

datablock ParticleEmitterData(SeawolfSiloRingEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 0;
	ejectionVelocity = 30.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 80;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfSiloRingParticle";
};

datablock ExplosionData(SeawolfSiloExhaustExplosion)
{

	lifeTimeMS = 150;

	particleEmitter = SeawolfSiloExhaustEmitter;
	particleDensity = 4;
	particleRadius = 0.2;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "3.0 10.0 3.0";
	camShakeDuration = 0.5;
	camShakeRadius = 20.0;

	// Dynamic light
	lightStartRadius = 5;
	lightEndRadius = 20;
	lightStartColor = "1 1 1 1";
	lightEndColor = "0 0 0 0";

	damageRadius = 0;
	radiusDamage = 0;

	impulseRadius = 0;
	impulseForce = 0;
};
datablock ExplosionData(SeawolfSiloRingExplosion)
{

	lifeTimeMS = 150;

	particleEmitter = SeawolfSiloRingEmitter;
	particleDensity = 4;
	particleRadius = 0.2;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "3.0 10.0 3.0";
	camShakeDuration = 0.5;
	camShakeRadius = 20.0;

	// Dynamic light
	lightStartRadius = 5;
	lightEndRadius = 20;
	lightStartColor = "1 1 1 1";
	lightEndColor = "0 0 0 0";

	damageRadius = 0;
	radiusDamage = 0;

	impulseRadius = 0;
	impulseForce = 0;
};
datablock ProjectileData(SeawolfSiloExhaustProjectile : vehicleFinalExplosionProjectile)
{
	directDamage        = 0;
	explosion           = "";//SeawolfSiloExhaustExplosion
	particleEmitter      =  SeawolfSiloExhaustEmitter;

	muzzleVelocity      = 20;
	velInheritFactor    = 1;

	armingDelay         = 10000;
	lifetime            = 5000;
	fadeDelay           = 000;
	bounceElasticity    = 0.2;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 1;

	hasLight    = true;
	lightRadius = 20;
	lightColor  = "1 0.5 0.0";
};
datablock ProjectileData(SeawolfSiloRingProjectile : vehicleFinalExplosionProjectile)
{
	directDamage        = 0;
	explosion           = SeawolfSiloRingExplosion;
	particleEmitter      =  SeawolfSiloRingEmitter;

	muzzleVelocity      = 20;
	velInheritFactor    = 1;

	armingDelay         = 10000;
	lifetime            = 1000;
	fadeDelay           = 000;
	bounceElasticity    = 0.2;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 1;

	hasLight    = true;
	lightRadius = 20;
	lightColor  = "1 1 1";
};



datablock ShapeBaseImageData(SeawolfSiloRingImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 0;
	rotation = eulerToMatrix( "90 0 0" );

	stateName[0]          = "Ready";
	stateTransitionOnTimeout[0]   = "FireA";
	stateTimeoutValue[0]      = 0.01;

	stateName[1]          = "FireA";
	stateTransitionOnTimeout[1]   = "Done";
	stateWaitForTimeout[1]      = True;
	stateTimeoutValue[1]      = 4;
	stateEmitter[1]         = SeawolfSiloRingEmitter;
	stateEmitterTime[1]       = 4;

	stateName[2]          = "Done";
	stateScript[2]          = "onDone";
};
function SeawolfSiloRingImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}
datablock ParticleData(SeawolfSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/bubble";
	spinSpeed       = 10.0;
	spinRandomMin       = -500.0;
	spinRandomMax       = 500.0;

	colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.9";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 0.25;
	sizes[1]      = 1.0;
	sizes[2]      = 1.75;

	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SeawolfSmokeEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 0.0;
	velocityVariance = 0.0;
	ejectionOffset   = -17.0;
	thetaMin         = 0;
	thetaMax         = 7;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfSmokeParticle";

};
datablock ParticleData(SeawolfTorpedoSmokeParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/bubble";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (255/255) SPC (255/255) SPC (100/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (75/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (50/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (10/255);

	sizes[0]      = 0.5;
	sizes[1]      = 0.8;
	sizes[2]      = 0.5;
	sizes[3]      = 0.3;

	times[0] = 0;
	times[1] = 0.3;
	times[2] = 0.7;
	times[3] = 1.0;
	useInvAlpha = true;
};
datablock ParticleEmitterData(SeawolfTorpedoSmokeEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 10.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 15;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfTorpedoSmokeParticle";
};
datablock ParticleData(SeawolfTorpedoDebrisSmokeParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (255/255) SPC (255/255) SPC (100/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (75/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (50/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (10/255);

	sizes[0]      = 1;
	sizes[1]      = 2;
	sizes[2]      = 3;
	sizes[3]      = 3;

	times[0] = 0;
	times[1] = 0.3;
	times[2] = 0.7;
	times[3] = 1.0;
	useInvAlpha = true;
};
datablock ParticleEmitterData(SeawolfTorpedoDebrisSmokeEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 10.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 15;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfTorpedoDebrisSmokeParticle";
};
datablock ParticleData(TorpedoExplosionParticle)
{
	dragCoefficient = 8;
	gravityCoefficient = -0.2;
	inheritedVelFactor = 1;
	constantAcceleration = 0;
	lifetimeMS = 2000;
	lifetimeVarianceMS = 1000;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10;
	spinRandomMin = -50;
	spinRandomMax = 50;
	colors[0] = "0.8 0.8 0.8 1";
	colors[1] = "0.8 0.8 0.8 0.8";
	colors[2] = "0.6 0.6 0.6 0.2";
	sizes[0] = 2;
	sizes[1] = 10;
	sizes[2] = 25;
	times[0] = 0;
	times[1] = 0.1;
	times[2] = 1;
	useInvAlpha = true;
};

datablock ParticleEmitterData(TorpedoExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 100;
	velocityVariance = 50;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 45;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "TorpedoExplosionParticle";
};
datablock ParticleData(TorpedoExplosionRingParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (238/255) SPC (238/255) SPC (10/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (100/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (1/255);

	sizes[0]      = 4;
	sizes[1]      = 4;
	sizes[2]      = 4;
	sizes[3]      = 8;

	times[0] = 0;
	times[1] = 0.3;
	times[2] = 0.7;
	times[3] = 1.0;
	useInvAlpha = true;
};

datablock ParticleEmitterData(TorpedoExplosionRingEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 0;
	ejectionVelocity = 30.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 80;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = true;
	particles = "TorpedoExplosionRingParticle";
};
datablock ParticleData(SeawolfICBMTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 5000;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/cloud";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (154/255) SPC (73/255) SPC (10/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (100/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (1/255);

	sizes[0]      = 2;
	sizes[1]      = 2.2;
	sizes[2]      = 1.5;
	sizes[3]      = 1.2;

	times[0] = 0;
	times[1] = 0.01;
	times[2] = 0.011;
	times[3] = 1.0;
	useInvAlpha = true;
};
datablock ParticleEmitterData(SeawolfICBMTrailEmitter)
{
	ejectionPeriodMS =10;
	periodVarianceMS = 0;
	ejectionVelocity = 30.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 15;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfICBMTrailParticle";
};
datablock ParticleData(SeawolfWarheadTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 10;
	textureName          = "./shapes/starFlare";
	spinSpeed      = 10.0;
	spinRandomMin     = -500.0;
	spinRandomMax     = 500.0;

	colors[0]     = (238/255) SPC (154/255) SPC (73/255) SPC (10/255);
	colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
	colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (100/255);
	colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (1/255);

	sizes[0]      = 5;
	sizes[1]      = 1;
	sizes[2]      = 0.5;
	sizes[3]      = 0.05;

	times[0] = 0;
	times[1] = 0.01;
	times[2] = 0.011;
	times[3] = 1.0;
	useInvAlpha = true;
};
datablock ParticleEmitterData(SeawolfWarheadTrailEmitter)
{
	ejectionPeriodMS =2;
	periodVarianceMS = 0;
	ejectionVelocity = 3.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 15;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfWarheadTrailParticle";
};
datablock ParticleData(SeawolfWarheadExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed       = 10.0;
	spinRandomMin       = -50.0;
	spinRandomMax       = 50.0;
	colors[0]     = "0.1 0.1 0.1 0.9";
	colors[1]     = "0.1 0.1 0.1 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SeawolfWarheadExplosionEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 1.0;
	ejectionOffset   = 3.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfWarheadExplosionParticle";

	emitterNode = TenthEmitterNode;
};


datablock ParticleData(SeawolfWarheadExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed       = 10.0;
	spinRandomMin       = -500.0;
	spinRandomMax       = 500.0;
	colors[0]     = "1 0.5 0.2 0.5";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 8;
	sizes[1]      = 13;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SeawolfWarheadExplosionRingEmitter)
{
	lifeTimeMS = 50;

	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 0.0;
	ejectionOffset   = 3.0;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "SeawolfWarheadExplosionRingParticle";

};