package packageSub
{
	function WheeledVehicleData::onAdd(%this,%obj)
	{
		if(%this.isSub) {
			%this.tickSub(%obj);
		}
		Parent::onAdd(%this, %obj);
	}
	

};
activatePackage(packageSub);

function WheeledVehicleData::onSubTick(%this,%obj) {

}
function repeatedVectorAddwithScale(%vecs)
{
	%vec="0 0 0";
	%cnt=getFieldCount(%vecs);
	for(%i=0;%i<%cnt;%i++)
	{
		%fld=getField(%vecs,%i);
		%tvec=getWords(%fld,0,3);
		%scale=getWord(%fld,3);
		%svec=vectorScale(%tvec,%scale);
		%vec=vectorAdd(%vec,%svec);
	}
	return %vec;
}

function SimObject::getLeftVector(%obj)
{
	return vectorCross(%obj.getEyeVector(),%obj.getUpVector());
}

function SimObject::getRightVector(%obj)
{
	return vectorScale(%obj.getLeftVector(%obj),-1);
}

function WheeledVehicleData::spawnWake(%this,%obj) {
	%data = %obj.getDatablock();

	%iPos= repeatedVectorAddwithScale(
		%obj.getEyeVector() SPC getWord(%data.wakeProjectilePosition,0) TAB
		%obj.getLeftVector() SPC getWord(%data.wakeProjectilePosition,1) TAB
		%obj.getUpVector() SPC getWord(%data.wakeProjectilePosition,2)
	);

	%wake = new Projectile()
	{
		dataBlock = %data.wakeProjectile;
		initialPosition = vectorAdd(%obj.pos,%iPos);
		initialVelocity = "0 0 -0.1";
	};

	if(isObject(%wake)) {
		MissionCleanup.add(%wake);
	}
			
}
function WheeledVehicleData::tickSub(%this,%obj,%cnt)
{	
	if(isObject(%obj)) {

		%tickMS = 2000;
		%data = %obj.getDatablock();

		%obj.water = WaterPlane;

		if (isObject(%obj.water)) {
			%tickMS = 10;

			%obj.waterLevel = getword(%obj.water.getTransform(),2) + %data.waterLine;

			%obj.speed = mFloor(vectorlen(%obj.getvelocity())+0.5);
			%obj.pos = %obj.getPosition();
			%obj.trans = %obj.getTransform();
			%obj.velocity = %obj.getvelocity();
			%obj.depth = mFloor(%obj.waterLevel-getword(%obj.pos,2)+0.5);
			%obj.height = getWord(%obj.trans,2);
			
			%obj.X = getWord(axisToEuler(%obj.trans),0);
			%obj.Y = getWord(axisToEuler(%obj.trans),1);
			%obj.Z = getWord(axisToEuler(%obj.trans),2);


			if(%obj.Y > 5) { // forward
				%obj.Y = %obj.Y - mAbs(%obj.Y/80);
			}
			if(%obj.Y < -5) { // backward
				%obj.Y = %obj.Y + mAbs(%obj.Y/80);
			}
			%obj.Y = %obj.Y - mClampF(%obj.Y/%obj.speed,-0.1,0.1);
			%obj.setTransform(%obj.getPosition() SPC eulerToAxis(%obj.X SPC %obj.Y SPC %obj.Z));

			if (getword(%obj.pos,2) > %obj.waterlevel && %obj.depthlock==false) {

				%obj.setvelocity(getWords(%obj.velocity,0,1) SPC mAbs(getWord(%obj.velocity,2)) * "-0.99");
			}
			// if (getword(%obj.pos,2) > %obj.waterlevel + 4) {
			// 	%obj.depthlock=false;
			// 	%obj.setvelocity("0 0"SPC "-10");
			// }

			if (getword(%obj.pos,2) < %obj.waterlevel - %this.submergeLevel) {
				if(%obj.speed > %this.maxSubmergeSpeed) {

					%obj.setvelocity(getWords(vectorscale(%obj.velocity,%this.SubmergeSpeedFactor),0,1) SPC getWord(%obj.getvelocity(),2));
				}
			}


			%cnt++;
			if(%cnt % (%this.tickDelay / 10) == 0) {
				%this.onSubTick(%obj);
			}

			if (%obj.depthlock==true)
			{
				if (%obj.lTrans==0)
					%obj.lTrans=getword(%obj.getTransform(),2);

				if (getword(%obj.pos,2) > %obj.lTrans)
					%obj.setvelocity(getwords(%obj.velocity,0,1) SPC "-0.3");
				else if (getword(%obj.pos,2) < %obj.lTrans)
					%obj.setvelocity(getwords(%obj.velocity,0,1) SPC "0.5");
			}
			else
				%obj.lTrans=0;


			
			
			

		}
		%this.schedule(%tickMS,tickSub,%obj,%cnt);
	}

}

// TGE to XYZ
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,6) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,3) * %sinThetaOver2;
	%q2 = getWord(%axis,4) * %sinThetaOver2;
	%q3 = getWord(%axis,5) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
