datablock AudioDescription(pingExt3d)
{
	volume   = 1;
	isLooping= false;
	is3D     = true;
	ReferenceDistance= 100.0;
	MaxDistance= 100.0;
	type     = $SimAudioType;
};
datablock AudioProfile(SeawolfPingSound)
{
	filename    = "./sounds/sub.wav";
	description = pingExt3d;
	preload = true;
};
datablock AudioProfile(SeawolfTorpedoFireSound)
{
	filename    = "./sounds/torpedo.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfTorpedoExplodeSound)
{
	filename    = "./sounds/torpedoExplode.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfMissileLaunchSound)
{
	filename    = "./sounds/missileLaunch.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfTorpedoWakeSound)
{
	filename    = "./sounds/torpedowake.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfTorpedoHomingWakeSound)
{
	filename    = "./sounds/homingtorpedowake.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfImpactSound1)
{
	filename    = "./sounds/impact1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfImpactSound2 : SeawolfImpactSound1)
{
	filename    = "./sounds/impact2.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(SeawolfAlarmSound)
{
	filename    = "./sounds/alarm.wav";
	description = AudioDefault3d;
	preload = true;
};




datablock ShapeBaseImageData(SeawolfHatchOpenImage)
{
	shapeFile = "./shapes/Hatch.dts";
	emap = false;

	mountPoint = 2;
	rotation = "0 0 0 0";

	stateName[0]                    = "Activate";
	stateTransitionOnTimeout[0]     = "Done";
	statesequence[0]                = "open";
	stateWaitForTimeout[0]          = true;
	stateTimeoutValue[0]            = 1;

	stateName[1]                    = "Done";
};
datablock ShapeBaseImageData(SeawolfHatchClosedImage)
{
	shapeFile = "./shapes/Hatch.dts";
	emap = false;

	mountPoint = 2;
	rotation = "0 0 0 0";
};
datablock ShapeBaseImageData(SeawolfHatchCloseImage)
{
	shapeFile = "./shapes/Hatch.dts";
	emap = false;

	mountPoint = 2;
	rotation = "0 0 0 0";


	stateName[0]                    = "Activate";
	stateTransitionOnTimeout[0]     = "Done";
	statesequence[0]                = "close";
	stateWaitForTimeout[0]          = true;
	stateTimeoutValue[0]            = 1;

	stateName[1]                    = "Done";

};

datablock ShapeBaseImageData(SeawolfProp)
{
	shapeFile = "./shapes/prop.dts";
	emap = false;

	mountPoint = 1;
	rotation = "0 1 0 0";

	stateName[0]                    = "Ready";
	stateTransitionOnTimeout[0]     = "FireA";
	stateTimeoutValue[0]            = 0.01;

	stateName[1]                    = "FireA";
	stateTransitionOnTimeout[1]     = "FireA";
	stateWaitForTimeout[1]          = true;
	stateSequence[1]                = "spin";
	stateTimeoutValue[1]            = 0.5;


};

datablock ShapeBaseImageData(SeawolfPropF)
{
	shapeFile = "./shapes/propf.dts";
	emap = false;

	mountPoint = 1;
	rotation = "0 1 0 0 ";
};

datablock DebrisData(SeawolfTorpedoDebris)
{
	emitters = "SeawolfTorpedoDebrisSmokeEmitter";

	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 0.5;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.4;
	numBounces = 0;
	staticOnMaxBounce = false;
	snapOnMaxBounce = true;
	fade = false;

	gravModifier = 10;
};

datablock ExplosionData(SeawolfTorpedoExplosion)
{

	lifeTimeMS = 400;
	explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";
	soundProfile = SeawolfTorpedoExplodeSound;
	debris = SeawolfTorpedoDebris;
	debrisNum = 10;
	debrisNumVariance = 10;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 90;
	debrisVelocity = 30;
	debrisVelocityVariance = 50;

	particleEmitter = TorpedoExplosionEmitter;
	particleDensity = 4;
	particleRadius = 0.2;

	emitter[0]  =   TorpedoExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "3.0 10.0 3.0";
	camShakeDuration = 0.5;
	camShakeRadius = 20.0;

	// Dynamic light
	lightStartRadius = 5;
	lightEndRadius = 20;
	lightStartColor = "1 1 1 1";
	lightEndColor = "0 0 0 0";

	damageRadius = 30;
	radiusDamage = 70;

	impulseRadius = 0;
	impulseForce = 0;
};
AddDamageType("SeawolfTorpedo",   '<color:FFFF00>[Seawolf Rocket]<color:FF0000> %1',    '%2 <color:FFFF00>[Seawolf Rocket]<color:FF0000> %1',0.2,1);
datablock ProjectileData(SeawolfTorpedoProjectile)
{
	projectileShapeName = "./shapes/torpedo.dts";
	directDamage        = 200;

	directDamageType    = $DamageType::SeawolfTorpedo;
	radiusDamageType    = $DamageType::SeawolfTorpedo;

	brickExplosionRadius = 0;
	brickExplosionImpact = true;          //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	sound = SeawolfTorpedoWakeSound;
	impactImpulse         = 000;
	verticalImpulse    = 0;
	explosion           = SeawolfTorpedoExplosion;
	particleEmitter     = SeawolfTorpedoSmokeEmitter;

	muzzleVelocity      = 50;
	velInheritFactor    = 1;
	explodeOnDeath       = 1;
	armingDelay         = 00;
	lifetime            = 10000;
	fadeDelay           = 000;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = false;
	gravityMod = 0.0;


	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
};
datablock ProjectileData(SeawolfTorpedoHomingProjectile)
{
	projectileShapeName = "./shapes/torpedo.dts";
	directDamage        = 200;

	directDamageType    = $DamageType::SeawolfTorpedo;
	radiusDamageType    = $DamageType::SeawolfTorpedo;

	brickExplosionRadius = 0;
	brickExplosionImpact = true;          //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	sound = SeawolfTorpedoHomingWakeSound;
	impactImpulse         = 000;
	verticalImpulse    = 0;
	explosion           = SeawolfTorpedoExplosion;
	particleEmitter     = SeawolfTorpedoSmokeEmitter;

	muzzleVelocity      = 38;
	velInheritFactor    = 1;
	explodeOnDeath       = 1;
	armingDelay         = 00;
	lifetime            = 10000;
	fadeDelay           = 000;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = false;
	gravityMod = 0.0;


	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
};



datablock DebrisData(SeawolfWarheadDebris)
{
	emitters = "MLRSExplosionDebrisEmitter";

	shapeFile = "./emptywheel.dts";
	lifetime = 0.5;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.4;
	numBounces = 0;
	staticOnMaxBounce = false;
	snapOnMaxBounce = true;
	fade = false;

	gravModifier = 10;
};

datablock ExplosionData(SeawolfWarheadExplosion)
{
	explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";
	soundProfile = rocketExplodeSound;

	lifeTimeMS = 1000;

	debris = SeawolfWarheadDebris;
	debrisNum = 30;
	debrisNumVariance = 10;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 180;
	debrisVelocity = 15;
	debrisVelocityVariance = 50;

	particleEmitter = SeawolfWarheadExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;

	emitter[0] = SeawolfWarheadExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "3.0 10.0 3.0";
	camShakeDuration = 0.5;
	camShakeRadius = 20.0;

	// Dynamic light
	lightStartRadius = 5;
	lightEndRadius = 20;
	lightStartColor = "1 1 0 1";
	lightEndColor = "1 0 0 0";


	playerBurnTime = 5000;

	impulseForce = 500;
	impulseRadius = 15;
	damageRadius = 20;
	radiusDamage = 25;
};

datablock ProjectileData(SeawolfICBMProjectile)
{
	projectileShapeName = "./shapes/ICBM.dts";
	directDamage        = 0;

	directDamageType    = $DamageType::ICBM;
	radiusDamageType    = $DamageType::ICBM;

	impactImpulse         = 0;
	verticalImpulse    = 0;
	explosion           = "";
	particleEmitter     = SeawolfICBMTrailEmitter;

	muzzleVelocity      = 60;

	lifetime            = 10000;
	fadeDelay           = 500;
};
datablock ProjectileData(SeawolfICBMProjectile2)
{
	projectileShapeName = "./shapes/ICBM.dts";
	directDamage        = 0;

	directDamageType    = $DamageType::ICBM;
	radiusDamageType    = $DamageType::ICBM;

	impactImpulse         = 0;
	verticalImpulse    = 0;
	explosion           = "";
	particleEmitter     = SeawolfICBMTrailEmitter;

	muzzleVelocity      = 60;

	lifetime            = 10000;
	fadeDelay           = 500;
};

datablock ProjectileData(SeawolfICBMWarhead)
{
	projectileShapeName = "./shapes/bulletprojectile.dts";
	directDamage        = 0;

	directDamageType    = $DamageType::ICBM;
	radiusDamageType    = $DamageType::ICBM;

	impactImpulse         = 0;
	verticalImpulse    = 0;
	explosion           = SeawolfWarheadExplosion;
	particleEmitter     = SeawolfWarheadTrailEmitter;

	muzzleVelocity      = 120;

	lifetime            = 10000;
	fadeDelay           = 500;
};
datablock ShapeBaseImageData(SeawolfSiloExhaustImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 0;
	offset = "0 0 1.5";
	rotation = eulerToMatrix( "90 0 0" );

	stateName[0]                    = "Ready";
	stateTransitionOnTimeout[0]     = "FireA";
	stateTimeoutValue[0]            = 0.01;

	stateName[1]                    = "FireA";
	stateTransitionOnTimeout[1]     = "FireB";
	stateWaitForTimeout[1]          = true;
	stateTimeoutValue[1]            = 1;
	stateEmitter[1]                 = SeawolfSiloRingEmitter;
	stateEmitterTime[1]             = 1;

	stateName[2]                    = "FireB";
	stateTransitionOnTimeout[2]     = "Done";
	stateWaitForTimeout[2]          = true;
	stateTimeoutValue[2]            = 1;
	stateEmitter[2]                 = SeawolfSiloExhaustEmitter;
	stateEmitterTime[2]             = 1;

	stateName[3]                    = "Done";
	stateScript[3]                  = "onDone";
};
function SeawolfSiloExhaustImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}
datablock WheeledVehicleData(SeawolfVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./shapes/Seawolf.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;

	numMountPoints = 1;
	mountThread[0] = "crouch";


	maxDamage = 200.00;
	destroyedLevel = 100.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
	// massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 30;         // Far distance from vehicle
	cameraOffset = 7;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.2;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = true;

	defaultTire = "";
	defaultSpring   = "";
	//flatTire  = jeepFlatTire;
	//flatSpring    = jeepFlatSpring;

	numWheels = 0;

	mass = 500;
	density = 1;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 1;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 100; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 30;        // Engine scale by current speed / max speed

	rollForce       = 600000;
	yawForce        = 3000000;
	pitchForce      = 2000000;
	rotationalDrag      = 0.1;
	forwardThrust       = 4000;
	reverseThrust       = 4000;
	lift            = 0;
	maxForwardVel       = 25;
	maxReverseVel       = 25;//2
	horizontalSurfaceForce  = 200;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce    = 200;
	stallSpeed      = 0;
	// Advanced Steering
	steeringAutoReturn = false;
	steeringUseStrafeSteering = false;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	exitSplashSoundVelocity = 5.0;

	//   explosion = VehicleExplosion;
	justcollided = 0;

	uiName = "Seawolf";
	rideable = true;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;

	paintable = true;

	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;         //offset only uses a z value for now

	burnTime = 3000;

	finalExplosionProjectile = SeawolffinalExplosionProjectile1;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now

	minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

	//protection for passengers
	protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
	protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
	protectPassengersDirect = true; //protect passengers from direct damage (bullets) ?
	heightcontrol= 1;       //Enables the heightcontrol support for this vehicle
	ascendVelocity= 1.3;    //The velocity it adds when a user presses/holds the jumpkey
	descendVelocity= -1;  //The velocity it extracts when a user presses/holds the jumpkey


	// sub settings
	isSub = 1;
	waterLine = -1;
	tickDelay = 500;
	submergeLevel       = 2;
	maxSubmergeSpeed    = 20;
	SubmergeSpeedFactor = 0.99;
	surfaceOffset = 1;

	uav_batteryCharge = 100;
	uav_batteryDecay = 0.5;
	uav_batteryLaserDecay = 2;
	uav_maxSignalDistance = 1000;
	uav_scanDistance = 500;
	uav_cooldown = 3000;
	uav_destroyCooldown = 20000;

	icbm_targetHeightOffset = 500;
	icbm_DetonationHeightDiffence = 300; // Distance from target to detonate
	icbm_warheadSpread = 0.005;
	icbm_warheadCount = 8;






	SeawolfShootOnClick=1;

	SeawolfShootOnClick_Hold[0] = 1;
	SeawolfShootOnClick_ShootDelay[0] = 3000;
	SeawolfShootOnClick_ReShootDelay[0] = 3000;
	SeawolfShootOnClick_ProjectileCount[0] = 1;
	SeawolfShootOnClick_RequiredSlot[0] = 0;
	SeawolfShootOnClick_Sound[0] = SeawolfTorpedoFireSound;
	SeawolfShootOnClick_fromSlot[0] = 0;
	SeawolfShootOnClick_useEye[0] = 1;
	SeawolfshootOnClick_FlashProjectile[0] = "SeawolfFireProjectile";

	SeawolfshootOnClick_Spread[0,0] = 0.0002;
	SeawolfShootOnClick_Projectile[0,0] = SeawolfTorpedoProjectile;
	SeawolfShootOnClick_Position[0,0] = "8 0 -1.5";//4
	SeawolfShootOnClick_Velocity[0,0] = "80 0 0";
	SeawolfShootOnClick_Scale[0,0] = "1 1 1";
	SeawolfShootOnClick_FlashVelocity[0,0] = "10 0 0";

	SeawolfShootOnClick_Hold[1] = 1;
	SeawolfShootOnClick_ShootDelay[1] = 3000;
	SeawolfShootOnClick_ReShootDelay[1] = 3000;
	SeawolfShootOnClick_ProjectileCount[1] = 1;
	SeawolfShootOnClick_RequiredSlot[1] = 0;
	SeawolfShootOnClick_Sound[1] = SeawolfTorpedoFireSound;
	SeawolfShootOnClick_fromSlot[1] = 0;
	SeawolfShootOnClick_useEye[1] = 1;
	SeawolfshootOnClick_FlashProjectile[1] = "SeawolfFireProjectile";

	SeawolfshootOnClick_Spread[1,0] = 0.0002;
	SeawolfShootOnClick_Projectile[1,0] = SeawolfTorpedoHomingProjectile;
	SeawolfShootOnClick_Position[1,0] = "8 0 -1.5";//4
	SeawolfShootOnClick_Velocity[1,0] = "50 0 0";
	SeawolfShootOnClick_Scale[1,0] = "1 1 1";
	SeawolfShootOnClick_FlashVelocity[1,0] = "10 0 0";

	SeawolfShootOnClick_Hold[2] = 0;
	SeawolfShootOnClick_ShootDelay[2] = 3000;
	SeawolfShootOnClick_ReShootDelay[2] = 3000;
	SeawolfShootOnClick_ProjectileCount[2] = 1;
	SeawolfShootOnClick_RequiredSlot[2] = 0;
	SeawolfShootOnClick_Sound[2] = SeawolfTorpedoFireSound;
	SeawolfShootOnClick_fromSlot[2] = 0;
	SeawolfShootOnClick_useEye[2] = 1;
	SeawolfshootOnClick_FlashProjectile[2] = "";

	SeawolfshootOnClick_Spread[2,0] = 0.0002;
	SeawolfShootOnClick_Projectile[2,0] = SeawolfMissileProjectile;
	SeawolfShootOnClick_Position[2,0] = "18 0 0";//4
	SeawolfShootOnClick_Velocity[2,0] = "100 0 0";
	SeawolfShootOnClick_Scale[2,0] = "1 1 1";
	SeawolfShootOnClick_FlashVelocity[2,0] = "30 0 0";

	SeawolfShootOnClick_Hold[3] = 0;
	SeawolfShootOnClick_ShootDelay[3] = 300;
	SeawolfShootOnClick_ReShootDelay[3] = 300;
	SeawolfShootOnClick_ProjectileCount[3] = 1;
	SeawolfShootOnClick_RequiredSlot[3] = 0;
	SeawolfShootOnClick_Sound[3] = SeawolfMissileLaunchSound;
	SeawolfShootOnClick_fromSlot[3] = 0;
	SeawolfShootOnClick_useEye[3] = 1;
	SeawolfshootOnClick_FlashProjectile[3] = "";

	SeawolfshootOnClick_Spread[3,0] = 0.0000;
	SeawolfShootOnClick_Projectile[3,0] = SeawolfICBMProjectile;
	SeawolfShootOnClick_Position[3,0] = "0 0 0.5";//4
	SeawolfShootOnClick_Velocity[3,0] = "0 0 60";
	SeawolfShootOnClick_Scale[3,0] = "1 1 1";
	SeawolfShootOnClick_FlashVelocity[3,0] = "30 0 0";




};
function SeawolfVehicle::onAdd(%this,%obj)
{

	//Spawn with these settings
	%obj.weaponi=0;
	%obj.weapon="Torpedo";
	%obj.missilefired=false;
	%obj.lTrans=0;
	%obj.ping = 0;
	%obj.ICBMStat = "Ready";
	%obj.depthlock = false;
	%obj.locking = false;
	%obj.playthread(0,down);
	%obj.mountimage(SeawolfPropf,1);
	%obj.mountimage(SeawolfHatchclosedimage,2);
	%obj.errorText = "";
	%obj.hasUAV = true;
	//%obj.getdatablock().schedule(500,"Scan",%obj);
	%this.tickSub(%obj);


}

function SeawolfVehicle::fireICBM(%this,%obj,%target)
{
	if (isObject(%obj))
	{
		%obj.unMountImage(2);
		%obj.mountimage(Seawolfhatchopenimage,2);
		%this.schedule(2000,"launchICBMExhaust",%obj,%obj.target);
	}
}
function SeawolfVehicle::launchICBMExhaust(%this,%obj,%target)
{
	if (isObject(%obj))
	{
		%obj.mountImage(SeawolfSiloExhaustImage,0);
		// %p = new Projectile()
		// {
		// 	dataBlock = SeawolfSiloExhaustProjectile;
		// 	initialVelocity  = "0 0 50";
		// 	initialPosition  = %obj.getPosition();
		// };
		// MissionCleanup.add(%p);
		%this.schedule(1500,"launchICBM",%obj,%obj.target);
	}
}
function SeawolfVehicle::launchICBM(%this,%obj,%target)
{
	if (isObject(%obj) && isObject(%obj.getMountNodeObject(0)))
	{
		%obj.getMountNodeObject(0).SeawolfSOC_Shoot(0,1,3,%target);
		%p = new Projectile()
		{
			dataBlock = SeawolfSiloRingProjectile;
			initialVelocity  = "0 0 50";
			initialPosition  = %obj.getPosition();
		};
		MissionCleanup.add(%p);

		%this.schedule(1500,"closeHatch",%obj,%obj.target);
	}
}
function SeawolfVehicle::closeHatch(%this,%obj,%target)
{
	if (isObject(%obj))
	{
		%obj.unMountImage(2);
		%obj.mountimage(Seawolfhatchcloseimage,2);
		%obj.ICBMStat = "\c0Reloading";
		%this.schedule(5000,"reload",%obj,%obj.target);
	}
}
function SeawolfVehicle::reload(%this,%obj,%target)
{
	if (isObject(%obj))
	{
		%obj.ICBMStat = "Ready";
	}
}
package Seawolf
{
	function servercmdLight(%client)
	{


		%p = %client.player;
		if (!isobject(%p.getobjectmount()))
			return Parent::servercmdLight(%client);

		%obj = %p.getobjectmount();

		if (%obj.getdatablock() == Seawolfvehicle.getid())
		{
			if (isObject(%obj.uav))
			{
				if (%obj.uav.laser && %obj.ICBMStat $= "FIRE [ R ]")
				{
					if ($Sim::Time < %obj.icbmFireTime + 10)
						return;
					%obj.icbmFireTime = $Sim::Time;
					%obj.ICBMStat = "\c0Launching";
					%obj.getDatablock().schedule(1500,"fireICBM",%obj,%obj.target);
				}
			}
			else
			{
				if (%obj.depthlock==true && %obj.outofWater==false)
				{
					%obj.depthlock=false;
					%obj.playthread(0,down);
				}
				else
				{
					%obj.depthlock=true;
					%obj.playthread(0,up);
				}
			}

		}
		else
			Parent::servercmdLight(%client);


	}
	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if (%col.getDataBlock() == SeawolfVehicle.getId())
		{
			%obj.setLookLimits(1,0);
			//%col.depthlock = false;

		}

	}
};
activatePackage(Seawolf);
function SeawolfVehicle::onRemove(%this,%obj)
{
	if (isObject(%obj.uav))
		%obj.uav.getDatablock().destroyUAV(%obj.uav, false);
	//return Parent::onRemove(%this,%obj);
}
function SeawolfVehicle::reloadUAV(%this,%obj)
{
	if (isObject(%obj))
	{
		%obj.hasUAV = true;
	}
}
function SeawolfVehicle::onSubTick(%this,%obj)
{

	if (!isObject(%obj.uav))
	{


		if (mfloor(getword(%obj.velocity,2)+0.5) > 0)
			%sign = " + ";
		else
			%sign = " - ";

		if (%obj.speed>5 && %obj.depth>-4)
		{
			%obj.unmountimage(1);
			%obj.mountimage(SeawolfProp,1);
		}
		else
		{
			%obj.unmountimage(1);
			%obj.mountimage(SeawolfPropf,1);
		}
		if (%obj.weaponi == 2)
		{
			if (%obj.hasUAV)
			{
				if (isObject(WaterPlane) && %obj.depth < SeawolfVehicle.surfaceOffset && %obj.depthlock)
				{
					%obj.errorText = "Ready";
				}
				else
				{
					%obj.errorText = "Maintain Depth, " SPC SeawolfVehicle.surfaceOffset;
				}


			}
			else
			{

				%obj.uavCooldown = %obj.uavCooldown - SeawolfVehicle.tickDelay;
				%obj.errorText = mCeil((($Sim::Time - %obj.uavCooldown) * -0.001) + (SeawolfVehicle.uav_destroyCooldown / 1000)) @ " sec.";
				if (%obj.uavCooldown < 0)
					%obj.hasUAV = true;
			}
		}
		commandToClient(%obj.getMountedObject(0).client,'bottomprint',
		                "<just:Left><font:Impact:20pt>\c3Knots\c6: " @ %obj.speed @
		                "\n<just:left><font:Impact:20pt>\c3Depth\c6: " @ %obj.depth @ %sign @
		                "<just:Right><font:Impact:20pt>\c3[ R ]Depth Lock\c6: " @ %obj.depthlock @
		                "<just:center><font:Impact:20pt>\c3[ > ] Armament\c6: " @ %obj.weapon , 2, 2, 3, 4);

		%obj.health = mFloor(-1*((%obj.getDamageLevel()/%obj.getDatablock().maxdamage)*100)+100 + 0.5);
		%center = "";
		if (%obj.weaponi == 1)
			%center = %obj.targetText;
		else if (%obj.weaponi == 2)
			%center = "\c3UAV:\c6 " SPC %obj.errorText;
		commandToclient(%obj.getMountedObject(0).client,'centerprint',"<just:left><font:Impact:24pt>" @ %center @
		                "<just:right><font:Impact:24pt>\c3Health:\c6 " @ %obj.health @ "%" @
		                "\n\n\n\n<just:center>[          ]" ,2,2,3,4);
	}
	else
	{

		%obj.uav.speed = mFloor(vectorlen(%obj.uav.getvelocity())+0.5);
		%obj.uav.status = "Ready";
		%obj.uav.UAVWarning = "";
		%obj.uav.battery-=SeawolfVehicle.uav_batteryDecay;
		%batteryColorRatio = 127.5;
		%batteryColor = "<color:" @ rgbToHex(mClamp(mAbs((%obj.uav.battery - 100)/%batteryColorRatio ) * 255 * 2,0,255) SPC mClamp(mAbs((%obj.uav.battery - 100)/%batteryColorRatio ) * 255 * -2 + 255,0,255) SPC 0) @ ">";

		%obj.uav.signalStrength = mFloor((vectorDist(%obj.getposition(),%obj.uav.getposition()) / SeawolfVehicle.uav_maxSignalDistance)*-100 + 100 + 0.5);
		%obj.uav.signalText = "";
		%signalColorRatio = 127.5;
		%signalColor = "<color:" @ rgbToHex(mClamp(mAbs((%obj.uav.signalStrength - 100)/%signalColorRatio ) * 255 * 2,0,255) SPC mClamp(mAbs((%obj.uav.signalStrength - 100)/%signalColorRatio ) * 255 * -2 + 255,0,255) SPC 0) @ ">";


		for (%i=0; %i<%obj.uav.signalStrength/20; %i++)
		{
			%obj.uav.signalText = %obj.uav.signalText @ "|";
		}
		// battery
		if (%obj.uav.battery <= 0)
			%obj.uav.getDatablock().destroyUAV(%obj.uav, false);


		if (%obj.uav.battery < 100/2)
			%obj.uav.UAVWarning = "Low Battery";



		if (vectorDist(%obj.uav.getposition(),%obj.getposition()) < 33 && %obj.uav.battery < 95)
			%obj.uav.getDatablock().destroyUAV(%obj.uav, true);

		if (strLen(%obj.uav.signalText) < 3)
			%obj.uav.UAVWarning = %obj.uav.UAVWarning SPC "Low Signal";

		// signalStrength
		if (strLen(%obj.uav.signalText) < 1)
			%obj.uav.getDatablock().destroyUAV(%obj.uav, false);



		if (%obj.uav.laser)
		{
			%obj.uav.battery-=SeawolfVehicle.uav_batteryLaserDecay;
			if (%obj.uav.status $= "Ready")
				%obj.uav.status = "Scanning for Coordinate";

			%eyeTrans = %obj.uav.getEyeTransform();
			%eyeVec = %obj.uav.getEyeVector();
			%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;
			%eyeEnd = VectorAdd(%eyeTrans,  VectorScale(VectorNormalize(%eyeVec), Seawolfvehicle.uav_scanDistance));
			%ray = ContainerRayCast(%eyeTrans, %eyeEnd, %mask,%obj);

			%rayPos = posFromRaycast(%ray);

			if (%rayPos)
			{

				%coord = mFloor(getWord(%rayPos,0)+0.5) SPC mFloor(getWord(%rayPos,1)+0.5) SPC mFloor(getWord(%rayPos,2)+0.5);

				%obj.uav.status = "Coorrdinate Locked [ \c0" @ %coord @ "\c6 ]";
				%obj.target = %coord;
				if (%obj.ICBMStat $= "Ready")
					%obj.ICBMStat = "FIRE [ R ]";
			}


			//%obj.uav.battery--;
			// %p = new Projectile()
			//  {
			//   dataBlock = vehicleExplosionProjectile;
			//   initialPosition = %coord;
			//   scale = "0.1 0.1 0.1";
			//  };
			// MissionCleanup.add(%p);

		}
		else
		{
			if (%obj.ICBMStat $= "FIRE [ R ]")
				%obj.ICBMStat = "Ready";
		}
		commandToclient(%obj.getMountedObject(0).client,'centerprint',
		                "<just:left><font:Impact:24pt>\c3ICBM:\c6 " @ %obj.ICBMStat @
		                "<just:right><font:Impact:24pt>" @ %signalColor @ %obj.uav.signalText @
		                "\n\n\n\n<just:center>\c0[          ]" @
		                "\n\n<just:center><font:Impact:24pt>\c0" @ %obj.uav.UAVWarning @ " " ,2,2,3,4);

		commandToClient(%obj.getMountedObject(0).client,'bottomprint',
		                "<just:Left><font:Impact:20pt>\c3Speed\c6: " @ %obj.uav.speed @
		                "<just:Right><font:Impact:20pt>\c3Battery\c6: " @ %batteryColor @ mCeil(%obj.uav.battery) @ "%" @
		                "<just:center><font:Impact:20pt>\c6 " @ %obj.uav.status, 2, 2, 3, 4);
	}
	Parent::onSubTick(%this,%obj);
}
function SeawolfVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
{
	if (%amm > 50)
	{
		if (%obj.health - %amm < 50)
			serverPlay3d("SeawolfAlarmSound",%obj.getposition());


	}
	else
	{
		%amm = %amm / 2;
	}
	return parent::Damage(%this,%obj,%source,%pos,%amm,%type);
}

function Seawolfvehicle::onImpact(%this,%obj,%data)
{

	if (%obj.speed > 7)
	{
		%obj.applydamage(vectorLen(%obj.speed*1));
		serverPlay3d("SeawolfImpactSound" @ getrandom(1,2),%obj.getposition());
		if (%obj.health - %obj.speed*1 < 50 && %obj.health - %obj.speed*2 > 0)
			serverPlay3d("SeawolfAlarmSound",%obj.getposition());
		if (%obj.health - %obj.speed*1 <= 0)
		{


			if (%obj.destroyed)
				return;
			%obj.setDamageLevel(0);
			%obj.destroyed = 1;

			%trans = %obj.getTransform();
			%p = new Projectile()
			{
				dataBlock = SeawolffinalExplosionProjectile1;
				initialVelocity  = "0 0 0";
				initialPosition  = %trans;
				client = %obj.getmountedobject(0).client;
				sourceClient = %obj.getmountedobject(0).client;
			};
			MissionCleanup.add(%p);


			%obj.schedule(10,"delete");
			if (isObject(%obj.spawnBrick.client.minigame))
				%respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
			%obj.spawnBrick.schedule(%respawn,"spawnVehicle");
		}
	}


}
function Seawolfvehicle::onTrigger(%this,%obj,%client)
{
	if (!%client.hasHeightControlClient)
	{
		%data= %obj.getDatablock();
		if (%data.heightcontrol)
		{
			if (getsimtime() >= %obj.lastHoverMove+$Server::HeightControl::delay)
			{
				%hSpeed = mFloor(getword(%obj.getvelocity(),2)+0.5);
				%velocity= "0 0 "@%data.ascendVelocity;
				if (%obj.getMountNodeObject(0).client.hoverTrigger == false)
				{
					%velocity= vectoradd(%obj.getVelocity(),getwords(vectorscale(%obj.getupvector(),%obj.getDataBlock().horizontalAccFactor),0,1) SPC getword(vectorscale(%obj.getupvector(),%obj.getDataBlock().ascendVelocity),2));
				}
				if (%hSpeed < 15)
				{
					%obj.setVelocity(%velocity);
				}
				%obj.lastHoverMove=getsimtime();
			}
		}
	}
}

function SeawolffinalExplosionProjectile1::onExplode(%this,%obj)
{
	%trans = %obj.getTransform();
	for (%i=2; %i<5; %i++)
	{
		%p[%i] = new Projectile()
		{
			dataBlock = "SeawolffinalExplosionProjectile" @ %i;
			initialVelocity  = "0 0 0";
			initialPosition  = %trans;
			sourceObject     = %obj;
			sourceSlot       = 0;
			client           = %obj.client;
			scale = "1 1 1";
		};
		MissionCleanup.add(%p[%i]);
	}

}

// TGE to XYZ
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,6) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,3) * %sinThetaOver2;
	%q2 = getWord(%axis,4) * %sinThetaOver2;
	%q3 = getWord(%axis,5) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

function rgbToHex( %rgb )
{
	%r = _compToHex( getWord( %rgb, 0 ) );
	%g = _compToHex( getWord( %rgb, 1 ) );
	%b = _compToHex( getWord( %rgb, 2 ) );
	%ans = %r @ %g @ %b;
	return %ans;
}
function _compToHex( %comp )
{
	%left = mFloor( %comp / 16 );
	%comp = mFloor( %comp - %left * 16 );

	%left = getSubStr( "0123456789ABCDEF", %left, 1 );
	%comp = getSubStr( "0123456789ABCDEF", %comp, 1 );

	return %left @ %comp;
}
