datablock ParticleData(SeawolfUAVExhaustParticle)
{
   dragCoefficient      = 10;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   lifetimeMS           = 8000;
   lifetimeVarianceMS   = 4000;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin     = -500.0;
   spinRandomMax     = 500.0;

   colors[0]     = (238/255) SPC (154/255) SPC (73/255) SPC (10/255);
   colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
   colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (70/255);
   colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (10/255);

   sizes[0]      = 1.2;
   sizes[1]      = 2;
   sizes[2]      = 2;
   sizes[3]      = 5;

   times[0] = 0;
   times[1] = 0.01;
   times[2] = 0.011;
   times[3] = 1.0;
   useInvAlpha = true;
};

datablock ParticleEmitterData(SeawolfUAVExhaustEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 30.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 15;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SeawolfUAVExhaustParticle";
};
datablock ExplosionData(SeawolfUAVExplosion : vehicleFinalExplosion)
{
	debris = "";
	impulseForce = 10;
	impulseVertical = 10;
	damageRadius = 15;
	radiusDamage = 130;
};
AddDamageType("SeawolfUAVExp",   '<color:FFFF00>[SeawolfUAV Missile]<color:FF0000> %1',    '%2 <color:FFFF00>[SeawolfUAV Missile]<color:FF0000> %1',0.2,1);
datablock ProjectileData(SeawolfUAVExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage        = 0;
   explosion           = SeawolfUAVExplosion;

   directDamageType  = $DamageType::SeawolfUAVExp;
   radiusDamageType  = $DamageType::SeawolfUAVExp;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;


};

datablock ShapeBaseImageData(SeawolfUAVLaserImage)
{
	shapeFile = "./shapes/laser.dts";
	emap = false;

	mountPoint = 1;
	offset = "0 0 -0.2";
	rotation = "1 0 0 0";
};
datablock WheeledVehicleData(SeawolfUAVVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./shapes/uav.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;

	numMountPoints = 1;
	mountThread[0] = "sit";

	maxDamage = 100.00;
	destroyedLevel =  100.00;
	extradamagethreshold = 2;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";

	maxSteeringAngle = 0.9;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 10;         // Far distance from vehicle
	cameraOffset = 2;        // Vertical offset from camera mount point
	cameraLag = 0.5;           // Velocity lag of camera
	cameraDecay = 0.5;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.0;
	collisionTol = 1.0;        // Collision distance tolerance
	contactTol = 1.0;

	useEyePoint = true;	

	defaultTire	  = "";
	defaultSpring = "";
	//flatTire	     = jeepFlatTire;
	//flatSpring	  = jeepFlatSpring;

	numWheels = 3;

	// Rigid Body
	mass = 100;
	density = 5.0;
	drag = 0.0;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 1;       // Play SoftImpact Sound
	hardImpactSpeed = 1;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 0; //4000;       // Engine power
	engineBrake = 50;         // Braking when throttle is 050
	brakeTorque = 4000;        // When brakes are applied
	maxWheelSpeed = 60;        // Engine scale by current speed / max speed




	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	isSled = false;

	forwardThrust		= 3000;
	reverseThrust		= 2000;
	lift			= 100;
	maxForwardVel		= 35;
	maxReverseVel		= 0;//2
	horizontalSurfaceForce	= 200;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 200; 

	rollForce		= 300;
	yawForce		= 400;
	pitchForce		= 500;
	rotationalDrag		= 3;
	stallSpeed		= 1;


	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;

	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";

	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

	rideable = true;
	lookUpLimit = 0.5;
	lookDownLimit = 0.5;

	paintable = true;


	numDmgEmitterAreas = 1;


	initialExplosionProjectile = jeepExplosionProjectile;
	initialExplosionOffset = 0;         //offset only uses a z value for now

	burnTime = 10;

	finalExplosionProjectile = SeawolfUAVExplosionProjectile;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now


	minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 50;   //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 0; //how hard a person you're running over gets pushed

	steeringUseStrafeSteering = false; //this vehicle has pitch control, so we can't use strafe steering

	minContrailSpeed = 50;
	mincollisionSpeed = 200;


};
function SeawolfUAVvehicle::onAdd(%this,%obj)
{
	%obj.battery = SeaWolfVehicle.uav_batteryCharge;

	%obj.laser = false;
	%obj.UAVWarning = "";
	%this.schedule(1000,"openWing",%obj);
}

function SeawolfUAVvehicle::openWing(%this,%obj)
{
	if(isObject(%obj)){
		%obj.pilot.client.setControlObject(%obj);
		%obj.playthread(0,"activate");
		%this.schedule(1000,"startEngine",%obj);
	}
	
}

function SeawolfUAVvehicle::startEngine(%this,%obj)
{
	if(isObject(%Obj)){
		%obj.playthread(0,"spin");
	}
}

function SeawolfUAVvehicle::destroyUAV(%this,%obj, %baseReturn) {
	if (isObject(%obj.pilot)) {
		if (isObject(%obj.sub)) {
			%obj.pilot.client.setControlObject(%obj.pilot.getObjectMount());
			%obj.pilot.client.setControlObject(%obj.pilot);
			%obj.pilot.setControlObject(%obj.pilot.getObjectMount());
			%obj.sub.uavCooldown = %Sim::Time;
			if (%baseReturn) {
				%obj.sub.hasUAV = true;
			}
			else {
				%obj.sub.hasUAV = false;
				%obj.sub.uavCooldown = SeawolfVehicle.uav_destroyCooldown;
			}
		} else {
			%obj.pilot.client.setControlObject(%obj.pilot);
		}

	}
	%obj.schedule(10,"delete");
}

package SeawolfUAV
{
	function SeawolfUAVVehicle::onTrigger(%db,%obj,%slot,%val)
	{

		if (isObject(%obj)){

			if (%slot == 0) {
				if (%val == 1) {
					%obj.mountImage(SeawolfUAVLaserImage,0);
					%obj.laser = true;
				}
				else {
					%obj.unmountImage(0);
					%obj.laser = false;
				}
			}
		}

	}
};
activatePackage(SeawolfUAV);
function SeawolfUAVVehicle::onDamage(%this,%obj,%col)
{

if((%obj.getDamageLevel()) == %this.maxDamage)
      {
		%this.destroyUAV(%obj,false);
      }
      else
     Parent::Damage(%this,%obj,%source,%pos,%amm,%type);


}
function SeawolfUAVvehicle::onCollision( %this, %obj, %col, %bool, %pos, %normal ) {
	if (%col.uav == %obj){
		%this.destroyUAV(%obj,true);
	} else {
		%this.destroyUAV(%obj,false);
		
	}
	return parent::onCollision( %this, %obj, %col, %bool, %pos, %normal);
	
}
function SeawolfUAVVehicle::onImpact(%this,%obj,%col)
{
	%this.destroyUAV(%obj,false);
}